#include "StdAfx.h"
#include "mainfrm.h"
#include "FileViewDlg.h"
#include "LiveViewDlg.h"
#include "htmlhelp.h"

LRESULT CMainFrame::OnViewRemoteFile(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CFileViewDlg dlg;
	if(dlg.DoModal() == IDOK)
	{
		if(m_FlowCtrl.GetPlayState() != STATE_STOP)
			SetWindowText(_T("Stopping..."));

		m_spControl->Stop();
		m_spControl->UseMediaServer(CComBSTR(dlg.m_sDCIPAddress));
		m_spControl->UseFile(CComBSTR(dlg.m_sFileName));
		(dlg.m_bUseTCP)? m_spControl->UseTCP() :  m_spControl->UseHTTP();

		SetWindowText(_T("Connecting..."));
		m_FlowCtrl.SetPlayMode(MODE_FILE);
		if(m_spControl->Play() == S_FALSE)
			SetWindowText(_T("Streaming Media Player"));
	}
	
	return 0;
}

LRESULT CMainFrame::OnViewRemoteLiveSource(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	CLiveViewDlg dlg;
	if(dlg.DoModal() == IDOK)
	{
		if(m_FlowCtrl.GetPlayState() != STATE_STOP)
			SetWindowText(_T("Stopping..."));

		m_spControl->Stop();
		m_spControl->UseMediaServer(CComBSTR(dlg.m_sDCIPAddress));

		(dlg.m_bUseLiveAlias)? m_spControl->UseLiveAlias(CComBSTR(dlg.m_sLiveAliasName)):
						  m_spControl->UseLiveDirect(CComBSTR(dlg.m_sLiveSourceIPAddress), dlg.m_nLiveSourceID);

		(dlg.m_bUseTCP)? m_spControl->UseTCP() :  m_spControl->UseHTTP();

		SetWindowText(_T("Connecting..."));
		m_FlowCtrl.SetPlayMode(MODE_LIVE);
		if(m_spControl->Play() == S_FALSE)
			SetWindowText(_T("Streaming Media Player"));
	}
	
	return 0;
}


LRESULT CMainFrame::OnViewProperties(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewProperties();

	return 0;
}

LRESULT CMainFrame::OnViewVideoSettings(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewVideoSettings();

	return 0;
}


LRESULT CMainFrame::OnSize50(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewHalfSize();

	return 0;
}

LRESULT CMainFrame::OnSize100(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewOriginalSize();

	return 0;
}

LRESULT CMainFrame::OnSize200(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewDoubleSize();

	return 0;
}

LRESULT CMainFrame::OnSizeFullscreen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	m_spControl->ViewFullScreenSize();

	return 0;
}

