using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;
using UMEDIASERVERLib;

namespace MediaServerUserAdmin
{
	/// <summary>
	/// Summary description for UserAdminForm.
	/// </summary>
	public class UserAdminForm : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.TextBox     UserName;
		protected System.Web.UI.WebControls.Label       Label1;
		protected System.Web.UI.WebControls.TextBox     Password;
		protected System.Web.UI.WebControls.Label       Label2;
		protected System.Web.UI.WebControls.TextBox     UserInfo;
		protected System.Web.UI.WebControls.Label       Label3;
		protected System.Web.UI.WebControls.Button      AddBtn;
		protected System.Web.UI.WebControls.RadioButton MediumGroupRadio;
		protected System.Web.UI.WebControls.RadioButton AdvancedGroupRadio;
		protected System.Web.UI.WebControls.RadioButton BasicGroupRadio;
		protected System.Web.UI.WebControls.Label       ErrorReport;
		protected System.Web.UI.WebControls.DataGrid    DataGrid1;

		private void Page_Load(object sender, System.EventArgs e)
		{
			// Load this data only once.
			if (IsPostBack == false) 
			{
				InitDataGrid();
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    						
			this.AddBtn.Click += new System.EventHandler(this.AddBtn_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private ICollection CreateDataSource() 
		{
			DataTable dt = new DataTable();
			DataRow dr;
 
			dt.Columns.Add(new DataColumn("User Name", typeof(string)));
			dt.Columns.Add(new DataColumn("Group", typeof(string)));
			dt.Columns.Add(new DataColumn("Info", typeof(string)));

			UsersAccess UUsers = new UsersAccess();
			string [] UsersList = (string[])UUsers.GetAllUsers();
 
			string strDelim = " ";
			char [] delimiter = strDelim.ToCharArray();

			for (int i = 0; i < UsersList.Length; i++) 
			{
				dr = dt.NewRow();			

				string strUserInfo = UsersList[i];
			
				// User info is returned in this form: "UserName UserGroup UserInfo".

				string [] strUsers = null;
				strUsers = strUserInfo.Split(delimiter);
 
				dr[0] = strUsers[0];
				dr[1] = strUsers[1];

				// There can be white spaces in User Info. So, we'll need to take care of that.
				// This is simple but not efficient way to do it. You're encouraged to improve it. ;-)
				string srtUserInfo = "";
				for (int j = 2; j < strUsers.Length; j++)
				{
					srtUserInfo += strUsers[j];
					srtUserInfo += " ";
				}

				dr[2] = srtUserInfo;
				dt.Rows.Add(dr);
			}
 
			DataView dv = new DataView(dt);
			return dv;
		}

		private void AddBtn_Click(object sender, System.EventArgs e)
		{
			int nGroup = 1;  // basic group
			if (MediumGroupRadio.Checked == true)
			{
				nGroup = 2;  // medium group
			}
			else if (AdvancedGroupRadio.Checked == true)
			{ 
				nGroup = 3;  // advanced group
			}

			// Call Media Server User manager to add a new user.
			UsersAccess UUsers = new UsersAccess();		
			string strStatus;
			UUsers.AddUser(UserName.Text, nGroup, Password.Text, UserInfo.Text, out strStatus);

			InitDataGrid();
			CheckError(strStatus);
		}

		protected void Command(Object Sender, DataGridCommandEventArgs e)
		{			
			if (e.CommandName == "RemoveUser")
			{
				// Call Media Server User manager to remove a user.
				UsersAccess UUsers = new UsersAccess();
				string strUserName = e.Item.Cells[1].Text;

				string strStatus;
				UUsers.DeleteUser(strUserName, out strStatus);

				InitDataGrid();
				CheckError(strStatus);
			}
		}

		private void InitDataGrid()
		{
			DataGrid1.DataSource = CreateDataSource();
			DataGrid1.DataBind();

			ClearFields();
		}

		private void CheckError(string strStatus)
		{
			if (strStatus != "Success")
			{
				ErrorReport.Text = strStatus;
			}
		}

		private void ClearFields()
		{
			UserName.Text    = "";
			Password.Text    = "";
			UserInfo.Text    = "";
			ErrorReport.Text = "";

			BasicGroupRadio.Checked    = true;
			MediumGroupRadio.Checked   = false;
			AdvancedGroupRadio.Checked = false;			
		}
	}
}
