VERSION 5.00
Object = "{CC48C56B-CD1D-4C19-8A46-6E2486CE9C8D}#1.0#0"; "UMediaControl.dll"
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Streaming Player"
   ClientHeight    =   5640
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5055
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5640
   ScaleWidth      =   5055
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton ParamsBtn 
      Caption         =   "Start"
      Height          =   255
      Left            =   120
      TabIndex        =   9
      Top             =   1560
      Width           =   4815
   End
   Begin VB.TextBox LiveSrcID 
      Height          =   375
      Left            =   4440
      TabIndex        =   8
      Top             =   960
      Width           =   495
   End
   Begin VB.TextBox MediaSourceAddress 
      Height          =   360
      Left            =   2520
      TabIndex        =   7
      Top             =   960
      Width           =   1815
   End
   Begin VB.OptionButton FileRadio 
      Caption         =   "File Source"
      Height          =   255
      Left            =   1680
      TabIndex        =   5
      Top             =   600
      Width           =   1215
   End
   Begin VB.OptionButton LiveRadio 
      Caption         =   "Live Source"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Value           =   -1  'True
      Width           =   1335
   End
   Begin VB.TextBox MediaServerPort 
      Height          =   360
      Left            =   4440
      TabIndex        =   2
      Text            =   "5119"
      Top             =   120
      Width           =   495
   End
   Begin VB.TextBox MediaServerIP 
      Height          =   360
      Left            =   2520
      TabIndex        =   1
      Top             =   120
      Width           =   1815
   End
   Begin UMediaControlLibCtl.UMediaPlayer UMediaPlayer 
      Height          =   3615
      Left            =   120
      OleObjectBlob   =   "StreamingPlayer.frx":0000
      TabIndex        =   0
      Top             =   1920
      Width           =   4815
   End
   Begin VB.Label MediaAddressLabel 
      Caption         =   "Live Media Source address && ID:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1080
      Width           =   2415
   End
   Begin VB.Label Label1 
      Caption         =   "Media Server address and port:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   240
      Width           =   2295
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' UMediaControl ActiveX Control's type library must be referenced in the project.
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

Dim InitialFormWidth As Integer

Private Sub Form_Load()
    InitialFormWidth = MainForm.Width
    UMediaPlayer.EnableFlowControl 0, 0  'Disable flow control and context menu
End Sub

Private Function GetMediaServer() As String
    Dim MediaServer As String
    MediaServer = MediaServerIP + ":" + MediaServerPort
    
    GetMediaServer = MediaServer
End Function

Private Sub FileRadio_Click()
    LiveSrcID.Visible = False
    MediaAddressLabel = "File location on Media Server:"
End Sub

Private Sub LiveRadio_Click()
    LiveSrcID.Visible = True
    MediaAddressLabel = "Live Media Source address && ID:"
End Sub

Private Sub Play()
    If MediaServerIP.Text = "" Or MediaSourceAddress.Text = "" Then
        MsgBox "Please enter Media Server and Media source addresses"
    Else
        Dim MediaServer As String
        MediaServer = GetMediaServer
        
        UMediaPlayer.UseTCP
        
        UMediaPlayer.UseMediaServer MediaServer  'Set Media Server address & port number
        
        If LiveRadio.Value = True Then
            UMediaPlayer.UseLiveDirect MediaSourceAddress.Text, LiveSrcID.Text 'Use Live source
        Else
            UMediaPlayer.UseFile MediaSourceAddress.Text                       'Use file source
        End If
            
        UMediaPlayer.Play   'Start playing
    End If
    
End Sub

Private Sub ParamsBtn_Click()
    Play
End Sub

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Control's callbacks
''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

' Gets called when the Streaming Media control pauses playing remote media
Private Sub UMediaPlayer_OnPause(ByVal bBuffering As Integer)
    MainForm.Caption = "Streaming Player - Paused"
End Sub

' Gets called when the Streaming Media control starts playing remote media
Private Sub UMediaPlayer_OnResize(ByVal nWidth As Integer, ByVal nHeight As Integer)
    Dim NewControlWidth  As Integer
    Dim NewControlHeight As Integer
    
    NewControlWidth = nWidth * Screen.TwipsPerPixelX    'nWidth is in pixels, not twips
    NewControlHeight = nHeight * Screen.TwipsPerPixelY  'nHeight is in pixels, not twips
    
    Dim ExtraWidth As Integer
    ExtraWidth = NewControlWidth - UMediaPlayer.Width
    
    MainForm.Width = NewControlWidth + 22 * Screen.TwipsPerPixelX

    If MainForm.Width < InitialFormWidth Then
        MainForm.Width = InitialFormWidth
    End If

    Dim ExtraHeight As Integer
    ExtraHeight = NewControlHeight - UMediaPlayer.Height
        
    MainForm.Height = MainForm.Height + ExtraHeight
    
    ParamsBtn.Width = NewControlWidth
        
    UMediaPlayer.Width = NewControlWidth
    UMediaPlayer.Height = NewControlHeight
End Sub

' Gets called when the Streaming Media control starts playing remote media
Private Sub UMediaPlayer_OnStart()
    UMediaPlayer.EnableFlowControl 1, 1             'Enable flow control and context menu
    MainForm.Caption = "Streaming Player - Playing"
End Sub

' Gets called when the Streaming Media control stops playing remote media
Private Sub UMediaPlayer_OnStop()
    UMediaPlayer_OnResize 320, 240
    UMediaPlayer.EnableFlowControl 0, 0             'Disable flow control and context menu
    MainForm.Caption = "Streaming Player"
End Sub

